//
//  Keyboard_iPadViewController.m
//  Keyboard iPad
//
//  Created by Devin Halperin on 7/29/10.
//  Copyright Opticon USA 2010. All rights reserved.
//

#import "Keyboard_iPadViewController.h"

@implementation Keyboard_iPadViewController

@synthesize textView;
@synthesize keyboardInputView = _keyboardInputView;

//UIView* tempView;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.

// Create an instance of the keyboardinputviewcontroller (custom keyboard).  Set the delegate to self and inputview to the custom
// keyboard.  Otherwise the system keyboard will be used.
- (void)viewDidLoad {
    [super viewDidLoad];
	self.keyboardInputView = [[[KeyboardInputViewController alloc] 
						  initWithNibName:@"KeyboardInputViewController" 
						  bundle:[NSBundle mainBundle]] autorelease];
	self.keyboardInputView.delegate = self;
	//tempView = textView.inputView;
	textView.inputView = self.keyboardInputView.view;
}



// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	self.keyboardInputView = nil;
    [super dealloc];
}

// Close the keyboard
-(void)closeTapped {
	[textView resignFirstResponder];
}

// Edit the text view with the character pressed on the keyboard.  Be sure to set the selected range appropriately.
-(void)buttonTapped:(NSString*)sender {
	NSRange theRange = textView.selectedRange;
	NSUInteger location = theRange.location;
	NSUInteger length = theRange.length;
	if ([sender isEqualToString:@"del"]) {
		if (location == 0 && length == 0) {
			return;
		}
		// If not a range, delete the character at the location returned
		if (length == 0) {
			if (location == textView.text.length) {
				textView.text = [textView.text substringToIndex:(location - 1)];
			} else {
				NSString* front = [textView.text substringToIndex:(location - 1)];
				NSString* back = [textView.text substringFromIndex:location];
				textView.text = [front stringByAppendingString:back];
				theRange.location = location - 1;
				textView.selectedRange = theRange;
			}
		} else {
			textView.text = [textView.text stringByReplacingCharactersInRange:theRange withString:@""];
			theRange.length = 0;
			textView.selectedRange = theRange;
		}
	} else {
		if (length == 0) {
			if (location == textView.text.length) {
				textView.text = [textView.text stringByAppendingString:sender];
			} else {
				textView.text = [textView.text stringByReplacingCharactersInRange:theRange withString:sender];
				theRange.location = location + 1;
				textView.selectedRange = theRange;
			}

		} else {
			textView.text = [textView.text stringByReplacingCharactersInRange:theRange withString:sender];
			theRange.location = location + 1;
			theRange.length = 0;
			textView.selectedRange = theRange;
		}

	}
}

@end
