    //
//  KeyboardInputViewController.m
//  Keyboard iPad
//
//  Created by Devin Halperin on 7/30/10.
//  Copyright 2010 Opticon USA. All rights reserved.
//

#import "KeyboardInputViewController.h"


@implementation KeyboardInputViewController

@synthesize delegate = _delegate;
@synthesize a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,period,comma,shift_one,shift_two,other_one,other_two;

// used to adjust the keyboard for the shift and other buttons.
BOOL shift = FALSE;
BOOL others = FALSE;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
    return YES;
}


- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	self.delegate = nil;
    [super dealloc];
}

// Send the character of the key that was tapped
- (IBAction) keyTapped:(id)sender {
	if (_delegate != nil) {
		[_delegate buttonTapped:[sender currentTitle]];
    }	
}

- (IBAction) closeTapped:(id)sender {
	if (_delegate != nil) {
        [_delegate closeTapped];
    }
}

- (IBAction) returnTapped:(id)sender {
	if (_delegate != nil) {
		[_delegate buttonTapped:@"\n"];	
	}
}


- (IBAction) deleteTapped:(id)sender {
	if (_delegate != nil) {
		[_delegate buttonTapped:@"del"];
	}
}


// Adjust the keyboard when a shift button is tapped.
- (IBAction) shiftTapped:(id)sender {
	if (_delegate != nil) {
		if (!shift && !others) {
			shift = TRUE;
			[a setTitle:@"A" forState:UIControlStateNormal];
			[b setTitle:@"B" forState:UIControlStateNormal];
			[c setTitle:@"C" forState:UIControlStateNormal];
			[d setTitle:@"D" forState:UIControlStateNormal];
			[e setTitle:@"E" forState:UIControlStateNormal];
			[f setTitle:@"F" forState:UIControlStateNormal];
			[g setTitle:@"G" forState:UIControlStateNormal];
			[h setTitle:@"H" forState:UIControlStateNormal];
			[i setTitle:@"I" forState:UIControlStateNormal];
			[j setTitle:@"J" forState:UIControlStateNormal];
			[k setTitle:@"K" forState:UIControlStateNormal];
			[l setTitle:@"L" forState:UIControlStateNormal];
			[m setTitle:@"M" forState:UIControlStateNormal];
			[n setTitle:@"N" forState:UIControlStateNormal];
			[o setTitle:@"O" forState:UIControlStateNormal];
			[p setTitle:@"P" forState:UIControlStateNormal];
			[q setTitle:@"Q" forState:UIControlStateNormal];
			[r setTitle:@"R" forState:UIControlStateNormal];
			[s setTitle:@"S" forState:UIControlStateNormal];
			[t setTitle:@"T" forState:UIControlStateNormal];
			[u setTitle:@"U" forState:UIControlStateNormal];
			[v setTitle:@"V" forState:UIControlStateNormal];
			[w setTitle:@"W" forState:UIControlStateNormal];
			[x setTitle:@"X" forState:UIControlStateNormal];
			[y setTitle:@"Y" forState:UIControlStateNormal];
			[z setTitle:@"Z" forState:UIControlStateNormal];
			[comma setTitle:@"!" forState:UIControlStateNormal];
			[period setTitle:@"?" forState:UIControlStateNormal];
		} else if (shift && !others) {
			shift = FALSE;
			[a setTitle:@"a" forState:UIControlStateNormal];
			[b setTitle:@"b" forState:UIControlStateNormal];
			[c setTitle:@"c" forState:UIControlStateNormal];
			[d setTitle:@"d" forState:UIControlStateNormal];
			[e setTitle:@"e" forState:UIControlStateNormal];
			[f setTitle:@"f" forState:UIControlStateNormal];
			[g setTitle:@"g" forState:UIControlStateNormal];
			[h setTitle:@"h" forState:UIControlStateNormal];
			[i setTitle:@"i" forState:UIControlStateNormal];
			[j setTitle:@"j" forState:UIControlStateNormal];
			[k setTitle:@"k" forState:UIControlStateNormal];
			[l setTitle:@"l" forState:UIControlStateNormal];
			[m setTitle:@"m" forState:UIControlStateNormal];
			[n setTitle:@"n" forState:UIControlStateNormal];
			[o setTitle:@"o" forState:UIControlStateNormal];
			[p setTitle:@"p" forState:UIControlStateNormal];
			[q setTitle:@"q" forState:UIControlStateNormal];
			[r setTitle:@"r" forState:UIControlStateNormal];
			[s setTitle:@"s" forState:UIControlStateNormal];
			[t setTitle:@"t" forState:UIControlStateNormal];
			[u setTitle:@"u" forState:UIControlStateNormal];
			[v setTitle:@"v" forState:UIControlStateNormal];
			[w setTitle:@"w" forState:UIControlStateNormal];
			[x setTitle:@"x" forState:UIControlStateNormal];
			[y setTitle:@"y" forState:UIControlStateNormal];
			[z setTitle:@"z" forState:UIControlStateNormal];
			[comma setTitle:@"," forState:UIControlStateNormal];
			[period setTitle:@"." forState:UIControlStateNormal];
		} else if (!shift && others) {
			shift = TRUE;
			[a setTitle:@"_" forState:UIControlStateNormal];
			[b setTitle:@"?" forState:UIControlStateNormal];
			[c setTitle:@"." forState:UIControlStateNormal];
			[d setTitle:@"|" forState:UIControlStateNormal];
			[e setTitle:@"{" forState:UIControlStateNormal];
			[f setTitle:@"~" forState:UIControlStateNormal];
			[g setTitle:@"<" forState:UIControlStateNormal];
			[h setTitle:@">" forState:UIControlStateNormal];
			[i setTitle:@"*" forState:UIControlStateNormal];
			[j setTitle:@"€" forState:UIControlStateNormal];
			[k setTitle:@"£" forState:UIControlStateNormal];
			[l setTitle:@"¥" forState:UIControlStateNormal];
			[m setTitle:@"'" forState:UIControlStateNormal];
			[n setTitle:@"!" forState:UIControlStateNormal];
			[o setTitle:@"+" forState:UIControlStateNormal];
			[p setTitle:@"=" forState:UIControlStateNormal];
			[q setTitle:@"[" forState:UIControlStateNormal];
			[r setTitle:@"}" forState:UIControlStateNormal];
			[s setTitle:@"\\" forState:UIControlStateNormal];
			[t setTitle:@"#" forState:UIControlStateNormal];
			[u setTitle:@"^" forState:UIControlStateNormal];
			[v setTitle:@"," forState:UIControlStateNormal];
			[w setTitle:@"]" forState:UIControlStateNormal];
			[y setTitle:@"%" forState:UIControlStateNormal];
			[comma setTitle:@"\"" forState:UIControlStateNormal];
			[shift_one setTitle:@"123" forState:UIControlStateNormal];
			[shift_two setTitle:@"123" forState:UIControlStateNormal];
		} else {
			shift = FALSE;
			[a setTitle:@"-" forState:UIControlStateNormal];
			[b setTitle:@"?" forState:UIControlStateNormal];
			[c setTitle:@"." forState:UIControlStateNormal];
			[d setTitle:@":" forState:UIControlStateNormal];
			[e setTitle:@"3" forState:UIControlStateNormal];
			[f setTitle:@";" forState:UIControlStateNormal];
			[g setTitle:@"(" forState:UIControlStateNormal];
			[h setTitle:@")" forState:UIControlStateNormal];
			[i setTitle:@"8" forState:UIControlStateNormal];
			[j setTitle:@"$" forState:UIControlStateNormal];
			[k setTitle:@"&" forState:UIControlStateNormal];
			[l setTitle:@"@" forState:UIControlStateNormal];
			[m setTitle:@"'" forState:UIControlStateNormal];
			[n setTitle:@"!" forState:UIControlStateNormal];
			[o setTitle:@"9" forState:UIControlStateNormal];
			[p setTitle:@"0" forState:UIControlStateNormal];
			[q setTitle:@"1" forState:UIControlStateNormal];
			[r setTitle:@"4" forState:UIControlStateNormal];
			[s setTitle:@"/" forState:UIControlStateNormal];
			[t setTitle:@"5" forState:UIControlStateNormal];
			[u setTitle:@"7" forState:UIControlStateNormal];
			[v setTitle:@"," forState:UIControlStateNormal];
			[w setTitle:@"2" forState:UIControlStateNormal];
			[y setTitle:@"6" forState:UIControlStateNormal];
			[comma setTitle:@"\"" forState:UIControlStateNormal];
			[shift_one setTitle:@"#+=" forState:UIControlStateNormal];
			[shift_two setTitle:@"#+=" forState:UIControlStateNormal];
		}
	}

	// make letters caps + change puncuations
}

// send space, when the space bar is tapped.
- (IBAction) spaceTapped:(id)sender {
	if (_delegate != nil) {
		[_delegate buttonTapped:@" "];
	}
}


// Adjust the keyboard when the other button is tapped.
- (IBAction) otherTapped:(id)sender {
	if (_delegate != nil) {
		if (!others) {
			others = TRUE;
			shift = FALSE;
			x.enabled = FALSE;
			x.alpha = 0;
			z.enabled = FALSE;
			z.alpha = 0;
			period.enabled = FALSE;
			period.alpha = 0;
			[a setTitle:@"-" forState:UIControlStateNormal];
			[b setTitle:@"?" forState:UIControlStateNormal];
			[c setTitle:@"." forState:UIControlStateNormal];
			[d setTitle:@":" forState:UIControlStateNormal];
			[e setTitle:@"3" forState:UIControlStateNormal];
			[f setTitle:@";" forState:UIControlStateNormal];
			[g setTitle:@"(" forState:UIControlStateNormal];
			[h setTitle:@")" forState:UIControlStateNormal];
			[i setTitle:@"8" forState:UIControlStateNormal];
			[j setTitle:@"$" forState:UIControlStateNormal];
			[k setTitle:@"&" forState:UIControlStateNormal];
			[l setTitle:@"@" forState:UIControlStateNormal];
			[m setTitle:@"'" forState:UIControlStateNormal];
			[n setTitle:@"!" forState:UIControlStateNormal];
			[o setTitle:@"9" forState:UIControlStateNormal];
			[p setTitle:@"0" forState:UIControlStateNormal];
			[q setTitle:@"1" forState:UIControlStateNormal];
			[r setTitle:@"4" forState:UIControlStateNormal];
			[s setTitle:@"/" forState:UIControlStateNormal];
			[t setTitle:@"5" forState:UIControlStateNormal];
			[u setTitle:@"7" forState:UIControlStateNormal];
			[v setTitle:@"," forState:UIControlStateNormal];
			[w setTitle:@"2" forState:UIControlStateNormal];
			[y setTitle:@"6" forState:UIControlStateNormal];
			[comma setTitle:@"\"" forState:UIControlStateNormal];
			[shift_one setTitle:@"#+=" forState:UIControlStateNormal];
			[shift_two setTitle:@"#+=" forState:UIControlStateNormal];
			[other_one setTitle:@"ABC" forState:UIControlStateNormal];
			[other_two setTitle:@"ABC" forState:UIControlStateNormal];
		} else {
			others = FALSE;
			shift = FALSE;
			x.enabled = TRUE;
			x.alpha = 1;
			z.enabled = TRUE;
			z.alpha = 1;
			period.enabled = TRUE;
			period.alpha = 1;
			[a setTitle:@"a" forState:UIControlStateNormal];
			[b setTitle:@"b" forState:UIControlStateNormal];
			[c setTitle:@"c" forState:UIControlStateNormal];
			[d setTitle:@"d" forState:UIControlStateNormal];
			[e setTitle:@"e" forState:UIControlStateNormal];
			[f setTitle:@"f" forState:UIControlStateNormal];
			[g setTitle:@"g" forState:UIControlStateNormal];
			[h setTitle:@"h" forState:UIControlStateNormal];
			[i setTitle:@"i" forState:UIControlStateNormal];
			[j setTitle:@"j" forState:UIControlStateNormal];
			[k setTitle:@"k" forState:UIControlStateNormal];
			[l setTitle:@"l" forState:UIControlStateNormal];
			[m setTitle:@"m" forState:UIControlStateNormal];
			[n setTitle:@"n" forState:UIControlStateNormal];
			[o setTitle:@"o" forState:UIControlStateNormal];
			[p setTitle:@"p" forState:UIControlStateNormal];
			[q setTitle:@"q" forState:UIControlStateNormal];
			[r setTitle:@"r" forState:UIControlStateNormal];
			[s setTitle:@"s" forState:UIControlStateNormal];
			[t setTitle:@"t" forState:UIControlStateNormal];
			[u setTitle:@"u" forState:UIControlStateNormal];
			[v setTitle:@"v" forState:UIControlStateNormal];
			[w setTitle:@"w" forState:UIControlStateNormal];
			[x setTitle:@"x" forState:UIControlStateNormal];
			[y setTitle:@"y" forState:UIControlStateNormal];
			[z setTitle:@"z" forState:UIControlStateNormal];
			[comma setTitle:@"," forState:UIControlStateNormal];
			[period setTitle:@"." forState:UIControlStateNormal];
			[shift_one setTitle:@"shift" forState:UIControlStateNormal];
			[shift_two setTitle:@"shift" forState:UIControlStateNormal];
			[other_one setTitle:@".?123" forState:UIControlStateNormal];
			[other_two setTitle:@".?123" forState:UIControlStateNormal];
		}
	}
}

@end
